diff -uNrd -x CVS ircd-hybrid-7rc5/src/channel_mode.c ircd-hybrid-7-bg/src/channel_mode.c
--- ircd-hybrid-7rc5/src/channel_mode.c	Sat Oct 12 00:33:31 2002
+++ ircd-hybrid-7-bg/src/channel_mode.c	Thu Mar 13 20:58:21 2003
@@ -19,12 +19,12 @@
  *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
  *  USA
  *
- *  $Id: channel_mode.c,v 7.64 2002/10/12 04:33:31 db Exp $
+ *  $Id: channel_mode.c,v 1.3 2003/03/13 16:34:05 demond Exp $
  */
 
 #include "stdinc.h"
 #include "setup.h"
-
+#include "config.h"
 #include "tools.h"
 #include "channel.h"
 #include "channel_mode.h"
@@ -67,6 +67,7 @@
 static char *fix_key(char *);
 static char *fix_key_old(char *);
 
+extern void clear_pace_queues(struct Channel *);
 
 static void chm_nosuch(struct Client *, struct Client *,
                        struct Channel *, int, int *, char **, int *, int,
@@ -110,6 +111,14 @@
                       int, int *, char **, int *, int, int, char, void *,
                       const char *chname);
 
+static void chm_subst(struct Client *, struct Client *, struct Channel *,
+                      int, int *, char **, int *, int, int, char, void *,
+                      const char *chname);
+
+static void chm_deny(struct Client *, struct Client *, struct Channel *,
+                     int, int *, char **, int *, int, int, char, void *,
+                     const char *chname);
+
 #ifdef ANONOPS
 static void chm_hideops(struct Client *, struct Client *, struct Channel *,
                         int, int *, char **, int *, int, int, char, void *,
@@ -150,7 +159,8 @@
 static int mode_limit;		/* number of modes set other than simple */
 static int simple_modes_mask;	/* bit mask of simple modes already set */
 
-static int channel_capabs[] = { CAP_HOPS, CAP_AOPS, CAP_EX, CAP_IE, CAP_UID };
+static int channel_capabs[] = { CAP_HOPS, CAP_AOPS, CAP_EX, 
+								CAP_IE, CAP_SW, CAP_DENY, CAP_UID };
 
 #define NCHCAPS         (sizeof(channel_capabs)/sizeof(int))
 #define NCHCAP_COMBOS   (1 << NCHCAPS)
@@ -207,7 +217,7 @@
   {
     if (MyClient(client_p))
     {
-      sendto_one(client_p, form_str(ERR_BANLISTFULL),
+      sendto_one(client_p, form_str(client_p,ERR_BANLISTFULL),
                  me.name, client_p->name, chptr->chname, banid);
       return 0;
     }
@@ -227,6 +237,12 @@
     case CHFL_INVEX:
       list = &chptr->invexlist;
       break;
+    case CHFL_SUBST:
+      list = &chptr->substlist;
+      break;
+    case CHFL_DENY:
+      list = &chptr->denylist;
+      break;
     default:
       sendto_realops_flags(FLAGS_ALL, L_ALL,
                            "add_id() called with unknown ban type %d!", type);
@@ -303,6 +319,12 @@
     case CHFL_INVEX:
       list = &chptr->invexlist;
       break;
+    case CHFL_SUBST:
+      list = &chptr->substlist;
+      break;
+    case CHFL_DENY:
+      list = &chptr->denylist;
+      break;
     default:
       sendto_realops_flags(FLAGS_ALL, L_ALL,
                            "del_id() called with unknown ban type %d!", type);
@@ -495,6 +517,23 @@
   if (chptr->mode.mode & MODE_HIDEOPS)
     *mbuf++ = 'a';
 #endif
+  if (chptr->mode.mode & MODE_NOCOLOR)
+    *mbuf++ = 'c';
+  if (chptr->mode.mode & MODE_REGCHAN)
+    *mbuf++ = 'r';
+  if (chptr->mode.mode & MODE_PACE)
+    *mbuf++ = 'x';
+  if (chptr->mode.mode & MODE_NOREPEAT)
+    *mbuf++ = 'z';
+  if (chptr->mode.mode & MODE_REGNICKS)
+    *mbuf++ = 'R';
+  if (chptr->mode.mode & MODE_REGSPEAK)
+    *mbuf++ = 'M';
+  if (chptr->mode.mode & MODE_CYRNICKS)
+    *mbuf++ = 'C';
+  if (chptr->mode.mode & MODE_SSLONLY)
+    *mbuf++ = 'S';
+
   if (chptr->mode.limit)
   {
     *mbuf++ = 'l';
@@ -686,6 +725,9 @@
 #define SM_ERR_RESTRICTED       0x00000080      /* Restricted chanop */
 #define SM_ERR_RPL_I            0x00000100
 #define SM_ERR_RPL_D            0x00000200
+#define SM_ERR_NOTSERVICES      0x00000400      /* not from services client */
+#define SM_ERR_CANTDEOPSERV		0x00000800		/* can't deop service bots */
+#define SM_ERR_RPL_W			0x00001000
 
 /* Now lets do some stuff to keep track of what combinations of
  * servers exist...
@@ -794,7 +836,7 @@
   if (*errors & SM_ERR_UNKNOWN)
     return;
   *errors |= SM_ERR_UNKNOWN;
-  sendto_one(source_p, form_str(ERR_UNKNOWNMODE), me.name, source_p->name, c);
+  sendto_one(source_p, form_str(source_p,ERR_UNKNOWNMODE), me.name, source_p->name, c);
 }
 
 static void
@@ -806,7 +848,20 @@
   long mode_type;
 
   mode_type = (long)d;
-
+  
+  if (mode_type & MODE_REGCHAN)
+  {
+    if (!(IsServer(source_p) || find_z_conf((char *)source_p->user->server)))
+    {
+      if (MyClient(source_p) && !(*errors & SM_ERR_NOTSERVICES))
+		sendto_one(source_p,
+			":%s NOTICE %s :*** NOTICE -- Chanmode +r can only be set by services",
+			me.name, source_p->name);
+	  *errors |= SM_ERR_NOTSERVICES;
+      return;
+	}
+  } 
+  else
   /* dont allow halfops to set +-p, as this controls whether they can set
    * +-h or not.. all other simple modes are ok
    */
@@ -814,7 +869,7 @@
     ((mode_type == MODE_PRIVATE) && (alev < CHACCESS_CHANOP)))
   {
     if (!(*errors & SM_ERR_NOOPS))
-      sendto_one(source_p, form_str(ERR_CHANOPRIVSNEEDED), me.name,
+      sendto_one(source_p, form_str(source_p,ERR_CHANOPRIVSNEEDED), me.name,
                  source_p->name, chname);
     *errors |= SM_ERR_NOOPS;
     return;
@@ -841,6 +896,8 @@
   else if ((dir == MODE_DEL) && (chptr->mode.mode & mode_type))
   {
     /* setting - */
+    if (mode_type & MODE_PACE)
+    	clear_pace_queues(chptr);
 
     chptr->mode.mode &= ~mode_type;
 
@@ -871,7 +928,7 @@
   if (alev < CHACCESS_HALFOP)
   {
     if (!(*errors & SM_ERR_NOOPS))
-      sendto_one(source_p, form_str(ERR_CHANOPRIVSNEEDED), me.name,
+      sendto_one(source_p, form_str(source_p,ERR_CHANOPRIVSNEEDED), me.name,
                  source_p->name, chname);
     *errors |= SM_ERR_NOOPS;
     return;
@@ -926,7 +983,7 @@
       DLINK_FOREACH(ptr, chptr->banlist.head)
       {
         banptr = ptr->data;
-        sendto_one(client_p, form_str(RPL_BANLIST),
+        sendto_one(client_p, form_str(client_p,RPL_BANLIST),
                    me.name, client_p->name, chname,
                    banptr->banstr, me.name, banptr->when);
       }
@@ -935,11 +992,11 @@
       DLINK_FOREACH(ptr, chptr->banlist.head)
       {
         banptr = ptr->data;
-        sendto_one(client_p, form_str(RPL_BANLIST),
+        sendto_one(client_p, form_str(client_p,RPL_BANLIST),
                    me.name, client_p->name, chname,
                    banptr->banstr, banptr->who, banptr->when);
       }
-    sendto_one(source_p, form_str(RPL_ENDOFBANLIST), me.name,
+    sendto_one(source_p, form_str(source_p,RPL_ENDOFBANLIST), me.name,
                source_p->name, chname);
     return;
   }
@@ -947,7 +1004,7 @@
   if (alev < CHACCESS_HALFOP)
   {
     if (!(*errors & SM_ERR_NOOPS))
-      sendto_one(source_p, form_str(ERR_CHANOPRIVSNEEDED), me.name,
+      sendto_one(source_p, form_str(source_p,ERR_CHANOPRIVSNEEDED), me.name,
                  source_p->name, chname);
     *errors |= SM_ERR_NOOPS;
     return;
@@ -1031,7 +1088,7 @@
   if (alev < CHACCESS_HALFOP)
   {
     if (!(*errors & SM_ERR_NOOPS))
-      sendto_one(source_p, form_str(ERR_CHANOPRIVSNEEDED), me.name,
+      sendto_one(source_p, form_str(source_p,ERR_CHANOPRIVSNEEDED), me.name,
                  source_p->name, chname);
     *errors |= SM_ERR_NOOPS;
     return;
@@ -1046,11 +1103,11 @@
     DLINK_FOREACH(ptr, chptr->exceptlist.head)
     {
       banptr = ptr->data;
-      sendto_one(client_p, form_str(RPL_EXCEPTLIST),
+      sendto_one(client_p, form_str(client_p,RPL_EXCEPTLIST),
                  me.name, client_p->name, chname,
                  banptr->banstr, banptr->who, banptr->when);
     }
-    sendto_one(source_p, form_str(RPL_ENDOFEXCEPTLIST), me.name,
+    sendto_one(source_p, form_str(source_p,RPL_ENDOFEXCEPTLIST), me.name,
                source_p->name, chname);
     return;
   }
@@ -1137,7 +1194,7 @@
   if (alev < CHACCESS_HALFOP)
   {
     if (!(*errors & SM_ERR_NOOPS))
-      sendto_one(source_p, form_str(ERR_CHANOPRIVSNEEDED), me.name,
+      sendto_one(source_p, form_str(source_p,ERR_CHANOPRIVSNEEDED), me.name,
                  source_p->name, chname);
     *errors |= SM_ERR_NOOPS;
     return;
@@ -1152,11 +1209,11 @@
     DLINK_FOREACH(ptr, chptr->invexlist.head)
     {
       banptr = ptr->data;
-      sendto_one(client_p, form_str(RPL_INVITELIST), me.name,
+      sendto_one(client_p, form_str(client_p,RPL_INVITELIST), me.name,
                  client_p->name, chname, banptr->banstr,
                  banptr->who, banptr->when);
     }
-    sendto_one(source_p, form_str(RPL_ENDOFINVITELIST), me.name,
+    sendto_one(source_p, form_str(source_p,RPL_ENDOFINVITELIST), me.name,
                source_p->name, chname);
     return;
   }
@@ -1221,6 +1278,220 @@
 }
 
 static void
+chm_subst(struct Client *client_p, struct Client *source_p,
+          struct Channel *chptr, int parc, int *parn,
+          char **parv, int *errors, int alev, int dir, char c, void *d,
+          const char *chname)
+{
+  char *mask, *raw_mask;
+  dlink_node *ptr;
+  struct Ban *banptr;
+
+  if(!ConfigChannel.use_subst && MyClient(source_p) && 
+    (dir == MODE_ADD) && (parc > *parn))
+  {
+    if((*errors & SM_ERR_RPL_W) != 0)
+      return;
+    
+    *errors |= SM_ERR_RPL_W;
+    return;
+  }
+
+  if (alev < CHACCESS_HALFOP)
+  {
+    if (!(*errors & SM_ERR_NOOPS))
+      sendto_one(source_p, form_str(source_p,ERR_CHANOPRIVSNEEDED), me.name,
+                 source_p->name, chname);
+    *errors |= SM_ERR_NOOPS;
+    return;
+  }
+
+  if ((dir == MODE_QUERY) || parc <= *parn)
+  {
+    if ((*errors & SM_ERR_RPL_W) != 0)
+      return;
+    *errors |= SM_ERR_RPL_W;
+
+    DLINK_FOREACH(ptr, chptr->substlist.head)
+    {
+      banptr = ptr->data;
+      sendto_one(client_p, form_str(client_p,RPL_SUBSTLIST), me.name,
+                 client_p->name, chname, banptr->banstr,
+                 banptr->who, banptr->when);
+    }
+    sendto_one(source_p, form_str(source_p,RPL_ENDOFSUBSTLIST), me.name,
+               source_p->name, chname);
+    return;
+  }
+
+  if (MyClient(source_p) && (++mode_limit > MAXMODEPARAMS))
+    return;
+
+  raw_mask = parv[(*parn)++];
+  if (IsServer(client_p))
+    mask = raw_mask;
+  else
+  /*  mask = pretty_mask(raw_mask);		messes up subst expression */
+    mask = raw_mask;
+
+  /* We'd have problems parsing this, hyb6 does it too */
+    if (strlen(mask) > (MODEBUFLEN - 2)) 
+      return; 
+
+  if(dir == MODE_ADD)
+  {
+    if((add_id(source_p, chptr, mask, CHFL_SUBST) == 0) && MyClient(source_p))
+      return;
+
+    mode_changes[mode_count].letter = c;
+    mode_changes[mode_count].dir = MODE_ADD;
+    mode_changes[mode_count].caps = CAP_SW;
+    mode_changes[mode_count].nocaps = 0;
+    
+    if(ConfigChannel.use_subst)
+      mode_changes[mode_count].mems = ONLY_CHANOPS_HALFOPS;
+    else
+      mode_changes[mode_count].mems = ONLY_SERVERS;
+
+    mode_changes[mode_count].id = NULL;
+    mode_changes[mode_count++].arg = mask;
+  }
+  else if (dir == MODE_DEL)
+  {
+    if (del_id(chptr, mask, CHFL_SUBST) == 0)
+    {
+      /* mask isn't a valid ban, check raw_mask */
+      if((del_id(chptr, raw_mask, CHFL_SUBST) == 0) && MyClient(source_p))
+      {
+        /* nope */
+        return;
+      }
+      mask = raw_mask;
+    }
+
+    mode_changes[mode_count].letter = c;
+    mode_changes[mode_count].dir = MODE_DEL;
+    mode_changes[mode_count].caps = CAP_SW;
+    mode_changes[mode_count].nocaps = 0;
+
+    if(ConfigChannel.use_subst)
+      mode_changes[mode_count].mems = ONLY_CHANOPS_HALFOPS;
+    else
+      mode_changes[mode_count].mems = ONLY_SERVERS;
+
+    mode_changes[mode_count].id = NULL;
+    mode_changes[mode_count++].arg = mask;
+  }
+}
+
+static void
+chm_deny(struct Client *client_p, struct Client *source_p,
+          struct Channel *chptr, int parc, int *parn,
+          char **parv, int *errors, int alev, int dir, char c, void *d,
+          const char *chname)
+{
+  char *mask, *raw_mask;
+  dlink_node *ptr;
+  struct Ban *banptr;
+
+  if(!ConfigChannel.use_denies && MyClient(source_p) && 
+    (dir == MODE_ADD) && (parc > *parn))
+  {
+    if((*errors & SM_ERR_RPL_D) != 0)
+      return;
+    
+    *errors |= SM_ERR_RPL_D;
+    return;
+  }
+
+  if (alev < CHACCESS_HALFOP)
+  {
+    if (!(*errors & SM_ERR_NOOPS))
+      sendto_one(source_p, form_str(source_p,ERR_CHANOPRIVSNEEDED), me.name,
+                 source_p->name, chname);
+    *errors |= SM_ERR_NOOPS;
+    return;
+  }
+
+  if ((dir == MODE_QUERY) || parc <= *parn)
+  {
+    if ((*errors & SM_ERR_RPL_D) != 0)
+      return;
+    *errors |= SM_ERR_RPL_D;
+
+    DLINK_FOREACH(ptr, chptr->denylist.head)
+    {
+      banptr = ptr->data;
+      sendto_one(client_p, form_str(client_p,RPL_DENYLIST), me.name,
+                 client_p->name, chname, banptr->banstr,
+                 banptr->who, banptr->when);
+    }
+    sendto_one(source_p, form_str(source_p,RPL_ENDOFDENYLIST), me.name,
+               source_p->name, chname);
+    return;
+  }
+
+  if (MyClient(source_p) && (++mode_limit > MAXMODEPARAMS))
+    return;
+
+  raw_mask = parv[(*parn)++];
+  if (IsServer(client_p))
+    mask = raw_mask;
+  else
+  /*  mask = pretty_mask(raw_mask);		messes up gecos deny expression */
+    mask = raw_mask;
+
+  /* We'd have problems parsing this, hyb6 does it too */
+    if (strlen(mask) > (MODEBUFLEN - 2)) 
+      return; 
+
+  if(dir == MODE_ADD)
+  {
+    if((add_id(source_p, chptr, mask, CHFL_DENY) == 0) && MyClient(source_p))
+      return;
+
+    mode_changes[mode_count].letter = c;
+    mode_changes[mode_count].dir = MODE_ADD;
+    mode_changes[mode_count].caps = CAP_DENY;
+    mode_changes[mode_count].nocaps = 0;
+    
+    if(ConfigChannel.use_denies)
+      mode_changes[mode_count].mems = ONLY_CHANOPS_HALFOPS;
+    else
+      mode_changes[mode_count].mems = ONLY_SERVERS;
+
+    mode_changes[mode_count].id = NULL;
+    mode_changes[mode_count++].arg = mask;
+  }
+  else if (dir == MODE_DEL)
+  {
+    if (del_id(chptr, mask, CHFL_DENY) == 0)
+    {
+      /* mask isn't a valid ban, check raw_mask */
+      if((del_id(chptr, raw_mask, CHFL_DENY) == 0) && MyClient(source_p))
+      {
+        /* nope */
+        return;
+      }
+      mask = raw_mask;
+    }
+
+    mode_changes[mode_count].letter = c;
+    mode_changes[mode_count].dir = MODE_DEL;
+    mode_changes[mode_count].caps = CAP_DENY;
+    mode_changes[mode_count].nocaps = 0;
+
+    if(ConfigChannel.use_denies)
+      mode_changes[mode_count].mems = ONLY_CHANOPS_HALFOPS;
+    else
+      mode_changes[mode_count].mems = ONLY_SERVERS;
+
+    mode_changes[mode_count].id = NULL;
+    mode_changes[mode_count++].arg = mask;
+  }
+}
+
+static void
 chm_op(struct Client *client_p, struct Client *source_p,
        struct Channel *chptr, int parc, int *parn,
        char **parv, int *errors, int alev, int dir, char c, void *d,
@@ -1249,7 +1520,7 @@
   if (alev < CHACCESS_CHANOP)
   {
     if (!(*errors & SM_ERR_NOOPS))
-      sendto_one(source_p, form_str(ERR_CHANOPRIVSNEEDED), me.name,
+      sendto_one(source_p, form_str(source_p,ERR_CHANOPRIVSNEEDED), me.name,
                  source_p->name, chname);
     *errors |= SM_ERR_NOOPS;
     return;
@@ -1279,7 +1550,7 @@
   if (!IsMember(targ_p, chptr))
   {
     if (!(*errors & SM_ERR_NOTONCHANNEL))
-      sendto_one(source_p, form_str(ERR_USERNOTINCHANNEL), me.name,
+      sendto_one(source_p, form_str(source_p,ERR_USERNOTINCHANNEL), me.name,
                  source_p->name, chname, opnick);
     *errors |= SM_ERR_NOTONCHANNEL;
     return;
@@ -1287,6 +1558,16 @@
 
   mode_get_status(chptr, targ_p, &t_op, &t_hop, &t_voice, 1);
 
+  if (find_z_conf((char *)targ_p->user->server) && !IsOper(source_p)
+	&& (dir == MODE_DEL) && (c == 'o') && t_op) 
+  {
+	if (MyClient(source_p) && !(*errors & SM_ERR_CANTDEOPSERV))
+	  sendto_one(source_p, form_str(source_p,ERR_CANTDEOPSERVICES),
+			me.name, source_p->name, targ_p->name, chname);
+	*errors |= SM_ERR_CANTDEOPSERV;
+	return;
+  }
+
   if (((dir == MODE_ADD) && t_op) ||
       ((dir == MODE_DEL) && !t_op
 #ifdef HALFOPS
@@ -1456,7 +1737,7 @@
         CHACCESS_CHANOP : CHACCESS_HALFOP))
   {
     if (!(*errors & SM_ERR_NOOPS))
-      sendto_one(source_p, form_str(ERR_CHANOPRIVSNEEDED), me.name,
+      sendto_one(source_p, form_str(source_p,ERR_CHANOPRIVSNEEDED), me.name,
                  source_p->name, chname);
     *errors |= SM_ERR_NOOPS;
     return;
@@ -1480,7 +1761,7 @@
   if (!IsMember(targ_p, chptr))
   {
     if (!(*errors & SM_ERR_NOTONCHANNEL))
-      sendto_one(source_p, form_str(ERR_USERNOTINCHANNEL), me.name,
+      sendto_one(source_p, form_str(source_p,ERR_USERNOTINCHANNEL), me.name,
                  source_p->name, chname, opnick);
     *errors |= SM_ERR_NOTONCHANNEL;
     return;
@@ -1598,7 +1879,7 @@
   if (alev < CHACCESS_HALFOP)
   {
     if (!(*errors & SM_ERR_NOOPS))
-      sendto_one(source_p, form_str(ERR_CHANOPRIVSNEEDED), me.name,
+      sendto_one(source_p, form_str(source_p,ERR_CHANOPRIVSNEEDED), me.name,
                  source_p->name, chname);
     *errors |= SM_ERR_NOOPS;
     return;
@@ -1617,7 +1898,7 @@
   if (!IsMember(targ_p, chptr))
   {
     if (!(*errors & SM_ERR_NOTONCHANNEL))
-      sendto_one(source_p, form_str(ERR_USERNOTINCHANNEL), me.name,
+      sendto_one(source_p, form_str(source_p,ERR_USERNOTINCHANNEL), me.name,
                  source_p->name, chname, opnick);
     *errors |= SM_ERR_NOTONCHANNEL;
     return;
@@ -1685,7 +1966,7 @@
   if (alev < CHACCESS_HALFOP)
   {
     if (!(*errors & SM_ERR_NOOPS))
-      sendto_one(source_p, form_str(ERR_CHANOPRIVSNEEDED), me.name,
+      sendto_one(source_p, form_str(source_p,ERR_CHANOPRIVSNEEDED), me.name,
                  source_p->name, chname);
     *errors |= SM_ERR_NOOPS;
     return;
@@ -1749,7 +2030,7 @@
   if (alev < CHACCESS_HALFOP)
   {
     if (!(*errors & SM_ERR_NOOPS))
-      sendto_one(source_p, form_str(ERR_CHANOPRIVSNEEDED), me.name,
+      sendto_one(source_p, form_str(source_p,ERR_CHANOPRIVSNEEDED), me.name,
                  source_p->name, chname);
     *errors |= SM_ERR_NOOPS;
     return;
@@ -1816,7 +2097,7 @@
   {chm_nosuch, NULL},
   {chm_nosuch, NULL},                             /* A */
   {chm_nosuch, NULL},                             /* B */
-  {chm_nosuch, NULL},                             /* C */
+  {chm_simple, (void *) MODE_CYRNICKS},           /* C */
   {chm_nosuch, NULL},                             /* D */
   {chm_nosuch, NULL},                             /* E */
   {chm_nosuch, NULL},                             /* F */
@@ -1826,13 +2107,13 @@
   {chm_nosuch, NULL},                             /* J */
   {chm_nosuch, NULL},                             /* K */
   {chm_nosuch, NULL},                             /* L */
-  {chm_nosuch, NULL},                             /* M */
+  {chm_simple, (void *) MODE_REGSPEAK},           /* M */
   {chm_nosuch, NULL},                             /* N */
   {chm_nosuch, NULL},                             /* O */
   {chm_nosuch, NULL},                             /* P */
   {chm_nosuch, NULL},                             /* Q */
-  {chm_nosuch, NULL},                             /* R */
-  {chm_nosuch, NULL},                             /* S */
+  {chm_simple, (void *) MODE_REGNICKS},           /* R */
+  {chm_simple, (void *) MODE_SSLONLY},            /* S */
   {chm_nosuch, NULL},                             /* T */
   {chm_nosuch, NULL},                             /* U */
   {chm_nosuch, NULL},                             /* V */
@@ -1849,18 +2130,18 @@
 #ifdef ANONOPS
   {chm_hideops, NULL},                            /* a */
 #else
-  {chm_nosuch, NULL},				  /* a */
+  {chm_nosuch, NULL},				              /* a */
 #endif
   {chm_ban, NULL},                                /* b */
-  {chm_nosuch, NULL},                             /* c */
-  {chm_nosuch, NULL},                             /* d */
+  {chm_simple, (void *) MODE_NOCOLOR},            /* c */
+  {chm_deny, NULL},                               /* d */
   {chm_except, NULL},                             /* e */
   {chm_nosuch, NULL},                             /* f */
   {chm_nosuch, NULL},                             /* g */
 #ifdef HALFOPS
   {chm_halfop, NULL},                             /* h */
 #else
-  {chm_nosuch, NULL},				  /* h */
+  {chm_nosuch, NULL},				              /* h */
 #endif
   {chm_simple, (void *) MODE_INVITEONLY},         /* i */
   {chm_nosuch, NULL},                             /* j */
@@ -1871,15 +2152,19 @@
   {chm_op, NULL},                                 /* o */
   {chm_simple, (void *) MODE_PRIVATE},            /* p */
   {chm_nosuch, NULL},                             /* q */
-  {chm_nosuch, NULL},                             /* r */
+  {chm_simple, (void *) MODE_REGCHAN},            /* r */
   {chm_simple, (void *) MODE_SECRET},             /* s */
   {chm_simple, (void *) MODE_TOPICLIMIT},         /* t */
   {chm_nosuch, NULL},                             /* u */
   {chm_voice, NULL},                              /* v */
-  {chm_nosuch, NULL},                             /* w */
-  {chm_nosuch, NULL},                             /* x */
+  {chm_subst, NULL},                              /* w */
+#ifdef USEPACE
+  {chm_simple, (void *) MODE_PACE},               /* x */
+#else
+  {chm_nosuch, NULL},				              /* x */
+#endif
   {chm_nosuch, NULL},                             /* y */
-  {chm_nosuch, NULL},                             /* z */
+  {chm_simple, (void *) MODE_NOREPEAT},           /* z */
 };
 /* *INDENT-ON* */
 
@@ -2041,6 +2326,7 @@
   int pbl, mbl, nc, mc;
   int i, st;
   int dir = MODE_QUERY;
+  int regular = 0;
 
   /* bail out if we have nothing to do... */
   if (!(mode_count
@@ -2053,14 +2339,26 @@
   /* Send all mode changes to the chanops/halfops, and even peons if
    * we are not +a...
    */
+  /*
+   * nah, don't send server bursting +e/+I/+d/+w to non-ops
+   */   
+   for (i=0; i < mode_count; i++) {
+     char c = mode_changes[i].letter;
+     if (c!='e' && c!='I' && c!='d' && c!='w') {
+     	regular = 1;
+     	break;
+     }
+   }
+   	
 #ifdef ANONOPS
-  st = (chptr->mode.mode & MODE_HIDEOPS) ? ONLY_CHANOPS_HALFOPS : ALL_MEMBERS;
+  st = (chptr->mode.mode & MODE_HIDEOPS) ? ONLY_CHANOPS_HALFOPS : 
+  	((regular)? ALL_MEMBERS : (IsServer(source_p)? ONLY_CHANOPS_HALFOPS : ALL_MEMBERS));
 #else
-  st = ALL_MEMBERS;
+  st = (regular)? ALL_MEMBERS : (IsServer(source_p)? ONLY_CHANOPS_HALFOPS : ALL_MEMBERS);
 #endif
 
   if (IsServer(source_p))
-    mbl = ircsprintf(modebuf, ":%s MODE %s ", me.name, chname);
+    mbl = ircsprintf(modebuf, ":%s MODE %s ", source_p->name, chname);
   else
     mbl = ircsprintf(modebuf, ":%s!%s@%s MODE %s ", source_p->name,
                      source_p->username, source_p->host, chname);
@@ -2091,7 +2389,7 @@
       mc = 0;
 
       if (IsServer(source_p))
-        mbl = ircsprintf(modebuf, ":%s MODE %s ", me.name, chname);
+        mbl = ircsprintf(modebuf, ":%s MODE %s ", source_p->name, chname);
       else
         mbl = ircsprintf(modebuf, ":%s!%s@%s MODE %s ", source_p->name,
                    source_p->username, source_p->host, chname);
diff -uNrd -x CVS ircd-hybrid-7rc5/src/class.c ircd-hybrid-7-bg/src/class.c
--- ircd-hybrid-7rc5/src/class.c	Thu Sep  5 10:06:16 2002
+++ ircd-hybrid-7-bg/src/class.c	Mon Mar 10 01:09:04 2003
@@ -19,7 +19,7 @@
  *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
  *  USA
  *
- *  $Id: class.c,v 7.37 2002/09/05 14:06:16 db Exp $
+ *  $Id: class.c,v 1.2 2003/03/10 06:09:04 demond Exp $
  */
 
 #include "stdinc.h"
@@ -304,7 +304,7 @@
   struct Class *cltmp;
 
   for (cltmp = ClassList; cltmp; cltmp = cltmp->next)
-    sendto_one(source_p, form_str(RPL_STATSYLINE), me.name, source_p->name,
+    sendto_one(source_p, form_str(source_p,RPL_STATSYLINE), me.name, source_p->name,
                'Y', ClassName(cltmp), PingFreq(cltmp), ConFreq(cltmp),
                MaxLinks(cltmp), MaxSendq(cltmp));
 }
diff -uNrd -x CVS ircd-hybrid-7rc5/src/client.c ircd-hybrid-7-bg/src/client.c
--- ircd-hybrid-7rc5/src/client.c	Thu Oct 10 14:49:30 2002
+++ ircd-hybrid-7-bg/src/client.c	Mon Mar 10 01:09:04 2003
@@ -19,7 +19,7 @@
  *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
  *  USA
  *
- *  $Id: client.c,v 7.302 2002/10/10 18:49:30 androsyn Exp $
+ *  $Id: client.c,v 1.4 2003/03/10 06:09:04 demond Exp $
  */
 #include "stdinc.h"
 #include "config.h"
@@ -422,7 +422,7 @@
 	reason = "Connection closed";
 
 	if(IsPerson(client_p))
-	  sendto_one(client_p, form_str(ERR_YOUREBANNEDCREEP),
+	  sendto_one(client_p, form_str(client_p,ERR_YOUREBANNEDCREEP),
 		     me.name, client_p->name,
 		     aconf->passwd ? aconf->passwd : "D-lined");
 	else
@@ -438,7 +438,7 @@
 	  reason = "D-lined";
 
 	if(IsPerson(client_p))
-	  sendto_one(client_p, form_str(ERR_YOUREBANNEDCREEP),
+	  sendto_one(client_p, form_str(client_p,ERR_YOUREBANNEDCREEP),
 		     me.name, client_p->name, reason);
 	else
 	  sendto_one(client_p, "NOTICE DLINE :*** You have been D-lined");
@@ -477,7 +477,7 @@
 	{
 	  reason = "Connection closed";
 
-	  sendto_one(client_p, form_str(ERR_YOUREBANNEDCREEP),
+	  sendto_one(client_p, form_str(client_p,ERR_YOUREBANNEDCREEP),
 		     me.name, client_p->name,
 		     aconf->passwd ? aconf->passwd : "G-lined");
 	} 
@@ -490,7 +490,7 @@
 	  else
 	    reason = "G-lined";
 
-	  sendto_one(client_p, form_str(ERR_YOUREBANNEDCREEP),
+	  sendto_one(client_p, form_str(client_p,ERR_YOUREBANNEDCREEP),
 		     me.name, client_p->name, reason);
 	}
 	
@@ -517,7 +517,7 @@
 	{
 	  reason = "Connection closed";
 
-	  sendto_one(client_p, form_str(ERR_YOUREBANNEDCREEP),
+	  sendto_one(client_p, form_str(client_p,ERR_YOUREBANNEDCREEP),
 		     me.name, client_p->name, 
 		     aconf->passwd ? aconf->passwd : "K-lined");
 	}
@@ -530,7 +530,7 @@
 	  else
 	    reason = "K-lined";
 
-	  sendto_one(client_p, form_str(ERR_YOUREBANNEDCREEP),
+	  sendto_one(client_p, form_str(client_p,ERR_YOUREBANNEDCREEP),
 		     me.name, client_p->name, reason);
 	}
 	      
@@ -570,7 +570,8 @@
   if (IsServer(client_p))
   {
     --Count.server;
-    sendto_realops_flags(FLAGS_EXTERNAL, L_ALL, 
+    if (!IsRelay(client_p))
+    	sendto_realops_flags(FLAGS_EXTERNAL, L_ALL, 
 			 "Server %s split from %s",
 			 client_p->name, client_p->servptr->name);
   }
@@ -581,6 +582,9 @@
       --Count.oper;
     if (IsInvisible(client_p)) 
       --Count.invisi;
+    if (client_p->svsflags & FLAGS_SVS_IDENT)
+      if (--Count.identified < 0)
+      	Count.identified = 0;
   }
 
   if(splitchecking && !splitmode)
@@ -775,7 +779,7 @@
     return who;
   if (!(who = get_history(user, (long)KILLCHASETIMELIMIT)))
     {
-      sendto_one(source_p, form_str(ERR_NOSUCHNICK),
+      sendto_one(source_p, form_str(source_p,ERR_NOSUCHNICK),
                  me.name, source_p->name, user);
       return (NULL);
     }
@@ -991,8 +995,11 @@
       add_history(source_p, 0);
       off_history(source_p);
 
+	  /* poof goes their watchlist! */
+	  hash_del_watch_list(source_p);
+
       if (HasID(source_p))
-	del_from_id_hash_table(source_p->user->id, source_p);
+		del_from_id_hash_table(source_p->user->id, source_p);
   
       /* again, this is all that is needed */
     }
@@ -1002,6 +1009,10 @@
    */
   del_from_client_hash_table(source_p->name, source_p);
 
+  /* remove user from watchlists */
+  if (IsRegistered(source_p))
+	hash_check_watch(source_p, RPL_LOGOFF);
+
   /* remove from global client list */
   remove_client_from_list(source_p);
 
@@ -1646,21 +1657,27 @@
   else
     {
       sendto_one(source_p,
-                 form_str(ERR_NICKTOOFAST),me.name, source_p->name,
+                 form_str(source_p,ERR_NICKTOOFAST),me.name, source_p->name,
                  source_p->name, nick, ConfigFileEntry.max_nick_time);
       return 0;
     }
 
   /* Finally, add to hash */
   del_from_client_hash_table(source_p->name, source_p);
+
+  hash_check_watch(source_p, RPL_LOGOFF);
+
   strcpy(source_p->name, nick);
   add_to_client_hash_table(nick, source_p);
 
+  hash_check_watch(source_p, RPL_LOGON);
+
   /* Make sure everyone that has this client on its accept list
    * loses that reference. 
    */
 
   del_all_accepts(source_p);
+  source_p->svsflags &= ~FLAGS_SVS_IDENT;
 
   /* fd_desc is long enough */
   fd_note(client_p->localClient->fd, "Nick: %s", nick);
@@ -1668,4 +1685,39 @@
   return 1;
 }
 
+static char cyr2lat[] = {
+  'A', 'B', 'V', 'G', 'D', 'E', 'Z', 'Z', 'I', 'J', 'K', 'L', 'M', 'N',
+  'O', 'P', 'R', 'S', 'T', 'U', 'F', 'H', 'C', '4', '6', '@', 'Y', '#',
+  'J', '#', 'U', 'Q',
+  'a', 'b', 'v', 'g', 'd', 'e', 'z', 'z', 'i', 'j', 'k', 'l', 'm', 'n',
+  'o', 'p', 'r', 's', 't', 'u', 'f', 'h', 'c', '4', '6', '@', 'y', '#',
+  'j', '#', 'u', 'q'
+};
 
+/*
+ * this will transpose cyrillic characters 
+ * into their latin phonetic counterparts
+ *
+ *                                -demond
+ */
+char *translate(struct Client *client_p, char *buf)
+{
+  unsigned char *p = buf;
+  int i, offset;
+
+  if (IsSetTransWin(client_p))
+    offset = 192;
+  else if (IsSetTransISO(client_p))
+    offset = 176;
+  else
+    return buf;
+
+  while (*p)
+    {
+      if ((*p >= offset) && (*p < offset + 2*32))
+		*p = cyr2lat[*p - offset];
+      ++p;
+    }
+
+  return buf;
+}
diff -uNrd -x CVS ircd-hybrid-7rc5/src/crypt.c ircd-hybrid-7-bg/src/crypt.c
--- ircd-hybrid-7rc5/src/crypt.c	Fri May 24 19:34:46 2002
+++ ircd-hybrid-7-bg/src/crypt.c	Mon Dec 30 23:07:26 2002
@@ -9,7 +9,7 @@
  *  this stuff is worth it, you can buy me a beer in return.  Poul-Henning Kamp
  *  ----------------------------------------------------------------------------
  *  
- *  $Id: crypt.c,v 7.4 2002/05/24 23:34:46 androsyn Exp $
+ *  $Id: crypt.c,v 1.1.1.1 2002/12/31 04:07:26 demond Exp $
  */
 
 #include "stdinc.h"
diff -uNrd -x CVS ircd-hybrid-7rc5/src/descrip.mms ircd-hybrid-7-bg/src/descrip.mms
--- ircd-hybrid-7rc5/src/descrip.mms	Thu May 23 18:20:15 2002
+++ ircd-hybrid-7-bg/src/descrip.mms	Mon Dec 30 23:07:26 2002
@@ -1,6 +1,6 @@
 # MMS/MMK Makefile for OpenVMS
 # Copyright (c) 2001 Edward Brocklesby
-# $Id: descrip.mms,v 7.10 2002/05/23 22:20:15 leeh Exp $
+# $Id: descrip.mms,v 1.1.1.1 2002/12/31 04:07:26 demond Exp $
 
 CC=	CC
 CFLAGS=/INCLUDE_DIRECTORY=([-.INCLUDE],[-.ADNS])/STANDARD=ISOC94/NOWARN -
diff -uNrd -x CVS ircd-hybrid-7rc5/src/dynlink.c ircd-hybrid-7-bg/src/dynlink.c
--- ircd-hybrid-7rc5/src/dynlink.c	Fri May 24 19:34:46 2002
+++ ircd-hybrid-7-bg/src/dynlink.c	Mon Dec 30 23:07:26 2002
@@ -19,7 +19,7 @@
  *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
  *  USA
  *
- * $Id: dynlink.c,v 7.3 2002/05/24 23:34:46 androsyn Exp $
+ * $Id: dynlink.c,v 1.1.1.1 2002/12/31 04:07:26 demond Exp $
  *
  */
 #include "stdinc.h"
@@ -314,9 +314,9 @@
 
   increase_modlist();
 
-  modlist [num_mods] = MyMalloc (sizeof (struct module));
-  modlist [num_mods]->address = tmpptr;
-  modlist [num_mods]->version = ver;
+  modlist[num_mods] = MyMalloc (sizeof (struct module));
+  modlist[num_mods]->address = tmpptr;
+  modlist[num_mods]->version = ver;
   modlist[num_mods]->core = core;
   DupString(modlist [num_mods]->name, mod_basename );
   num_mods++;
diff -uNrd -x CVS ircd-hybrid-7rc5/src/event.c ircd-hybrid-7-bg/src/event.c
--- ircd-hybrid-7rc5/src/event.c	Fri Sep 20 01:31:55 2002
+++ ircd-hybrid-7-bg/src/event.c	Mon Dec 30 23:07:26 2002
@@ -38,7 +38,7 @@
  *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
  *  USA
  *
- *  $Id: event.c,v 7.29 2002/09/20 05:31:55 db Exp $
+ *  $Id: event.c,v 1.1.1.1 2002/12/31 04:07:26 demond Exp $
  */
 
 /*
